this.name			= "SIRF_ship_script";
this.author			= "Montana05";
this.description	= "ship script for SIRF.OXP";
this.version		= "2.60";
this.copyright		= "2021 Montana05";
this.licence   		= "CC BY-NC-SA 4.0";
"use strict";

this.shipSpawned = function(ship)
{
	this.$SIRF_shipType = this.ship.dataKey;
	var dice = 0;

	if(this.ship.hasRole("escape-capsule"))
	{
		// neutral inits first
		var crewName = expandDescription("[nom]");
		var crewDescription = "a crew member of an evacuated ship";
		var crewRole = "hunter";  // not perfect but somewhere in the middle
		var crewRace = expandDescription("[[MRP01_GalCop_races_scientific]");  // add a race to the crew members
		
		this.$SIRF_crew_ranks_fighter_Array = ["Gunner", "Co-Pilot", "Pilot", "Commander"];
		var $SIRF_crew_ranks_fighter = 
		$SIRF_crew_ranks_fighter_Array[Math.floor(Math.random() * $SIRF_crew_ranks_fighter_Array.length)];

		this.$SIRF_station_Array = ["an employee", "a resident", "a visitor"];
		var $SIRF_station = 
		$SIRF_station_Array[Math.floor(Math.random() * $SIRF_station_Array.length)];

		switch(this.$SIRF_shipType) 
		{
			case "SIRF_worm_prospector_lifeboat":

				dice = this.$getRndInteger(1, 5);

				if(dice == 5)
				{	
					crewName = ("the " + crewRace + " Pilot " + expandDescription("[nom]"));
					crewDescription = "a SIRF ship crew member";
					crewRole = "trader";
				}
				else
				{	
					crewName = ("the " + crewRace + " " + expandDescription("[nom]"));
					crewDescription = ($SIRF_station + " " + "of a SIRF station");
					crewRole = "passenger";
				};	
				
				this.ship.switchAI("homeAI.plist");
				break;
			
			case "SIRF_escape_pod_SIRF":
				
				crewName = ("the " + crewRace + " " + expandDescription("[nom]"));
				crewDescription = ($SIRF_station + " " + "of a SIRF station");
				crewRole = "passenger";
				break;
						
			case "SIRF_escape_capsule_SIRF":

				dice = this.$getRndInteger(1, 5);

				if(dice == 5)
				{	
					crewName = ("the " + crewRace + " Pilot " + expandDescription("[nom]"));
					crewDescription = "a SIRF ship crew member";
					crewRole = "trader";
				}
				else
				{	
					crewName = ("the " + crewRace + " " + expandDescription("[nom]"));
					crewDescription = "a traveller on a SIRF ship";
					crewRole = "passenger";
				};	
				break;

			case "SIRF_escape_suit_SIRF":
			
				crewName = ("the " + crewRace + " Specialist " + expandDescription("[nom]"));
				crewDescription = "a prospector of a SIRF station";
				crewRole = "miner";
				break;
				
			case "SIRF_escape_capsule":
			case "SIRF_escape_capsule_ssg":	
		
				crewName = ("the " + crewRace + " " + $SIRF_crew_ranks_fighter + " " + expandDescription("[nom]"));
				
				if(this.$SIRF_shipType == "SIRF_escape_capsule")
					crewDescription = "a ship crew member";
				else
				{	
					crewDescription = "a SSG ship crew member";
				};
				
				crewRole = "hunter";
				break;
			
			case "SIRF_escape_capsule_neutral":
			case "SIRF_escape_suit_neutral":	
							
				if(this.$SIRF_shipType == "SIRF_escape_suit_neutral")
					dice = 5;
				else
				{	
					dice = this.$getRndInteger(1, 5);
				};	

				if(dice == 5)
				{	
					crewName = ("the " + crewRace + " Pilot " + expandDescription("[nom]"));
					crewDescription = "a ship crew member";
					crewRole = "trader";
				}
				else
				{	
					crewName = ("the " + crewRace + " " + expandDescription("[nom]"));
					crewDescription = "a interplanetar passenger";
					crewRole = "passenger";
				};
				break;	

			case "SIRF_escape_capsule_SIRF_pirate":
			case "SIRF_escape_suit_SIRF_pirate":
			case "SIRF_escape_suit_pirate":
			case "SIRF_escape_capsule_pirate":
			case "SIRF_escape_capsule_ssg_pirate":			
		
				crewName = ("the " + crewRace + " " + expandDescription("[[MRP01_pirate_nicknames]") + expandDescription("[nom]"));
				crewDescription = "a criminal wanted by GalCop police";
				crewRole = "pirate";
				break;	
				
			default: 
				break;		
		};

		this.ship.setCrew
		(
			{
				name: crewName,
				short_description: crewDescription,
				role: crewRole,
				species: crewRace
			}
		);

		// remove individual roles
		this.ship.primaryRole = "escape-capsule";
	}
	else
	{
		switch(this.$SIRF_shipType) 
		{
			case "SIRF_shuttle_system":
			case "SIRF_shuttle_system_team_01":	
		
				if(this.ship.cargoSpaceUsed <= 15)
				{
					var coinFlip = this.$getRndInteger(1, 2);
				
					if(coinFlip == 1)
					{
						this.ship.adjustCargo(this.$stationCargo(1), 5);
						this.ship.adjustCargo(this.$stationCargo(1), 5);
					}
					else 
					{
						this.ship.adjustCargo(this.$stationCargo(2), 5);
						this.ship.adjustCargo(this.$stationCargo(2), 5);
					};	
				};
			
				if(this.ship.primaryRole = "escort")
					this.ship.switchAI("oolite-escortAI.js");
				else
				{
					this.ship.switchAI("oolite-shuttleAI.js");
				};	
				
				this.ship.primaryRole = "shuttle";
				break;

			case "SIRF_shuttle_system_neutral":
			case "SIRF_shuttle_system_neutral_team_01":

				this.ship.setCargoType("PLENTIFUL_GOODS");
				this.ship.switchAI("oolite-shuttleAI.js");
				this.ship.primaryRole = "shuttle";
				break;

			case "SIRF_worm_prospector":
				
				this.ship.switchAI("oolite-scavengerAI.js");
				break;
			
			case "SIRF_worm_prospector_miner":
			
				this.ship.switchAI("minerAI.plist");
				this.ship.primaryRole = "miner";
				break;
			
			case "SIRF_gecko_dragon":
			case "SIRF_gecko_dragon_ssg":
			case "SIRF_gecko_dragon_ssg_team_01":
			case "SIRF_gecko_dragon_ssg_team_02":
			
				if(this.ship.cargoSpaceUsed <= 1)
				{
					this.ship.adjustCargo("firearms", 1);
					this.ship.adjustCargo("food", 1);
				};
				
				if(this.$SIRF_shipType == "SIRF_gecko_dragon_ssg_team_01")
				{
					this.ship.switchAI("oolite-bountyHunterAI.js");
					this.ship.primaryRole = "hunter";
				};
				break;

			case "SIRF_gecko_dragon_pirate":
				
				this.ship.setCargoType("PLENTIFUL_GOODS");
				
				// individual role of the ship, will only be called from other OXP's 
				if(this.ship.primaryRole == "SIRF_gecko_dragon_pirate")
					this.ship.primaryRole = "pirate";
				break;		

			default: 
				break;		
		};	
	};
};

// resets accidental bounties

this.shipBeingAttackedUnsuccessfully = function(whom)
{
	if((this.ship.primaryRole == "SIRF-YARD" || this.ship.primaryRole == "defense_ship") && this.ship.bounty > 0 && whom.isPolice)
	{	
		if(whom && whom.isValid && ship && ship.isValid)
		{
			whom.target = null;
			whom.reactToAIMessage("TARGET_LOST");
			whom.removeDefenseTarget(this.ship);

			this.ship.target = null;
			this.ship.reactToAIMessage("TARGET_LOST");
			this.ship.removeDefenseTarget(whom);

			this.ship.bounty = 0;
			this.ship.setBounty(0, "friendly fire");
		};
	};	
};

this.shipBeingAttacked = function(whom)
{
	if((this.ship.primaryRole == "SIRF-YARD" || this.ship.primaryRole == "defense_ship") && this.ship.bounty > 0 && whom.isPolice)
	{	
		if(whom && whom.isValid && ship && ship.isValid)
		{
			whom.target = null;
			whom.reactToAIMessage("TARGET_LOST");
			whom.removeDefenseTarget(this.ship);

			this.ship.target = null;
			this.ship.reactToAIMessage("TARGET_LOST");
			this.ship.removeDefenseTarget(whom);

			this.ship.bounty = 0;
			this.ship.setBounty(0, "friendly fire");
		};
	};	
};

this.shipAttackedWithMissile = function(missile, whom)
{
    if((this.ship.primaryRole == "SIRF-YARD" || this.ship.primaryRole == "defense_ship") && this.ship.bounty > 0 && whom.isPolice)
	{	
		if(whom && whom.isValid && ship && ship.isValid)
		{
			whom.target = null;
			whom.reactToAIMessage("TARGET_LOST");
			whom.removeDefenseTarget(this.ship);

			this.ship.target = null;
			this.ship.reactToAIMessage("TARGET_LOST");
			this.ship.removeDefenseTarget(whom);

			this.ship.bounty = 0;
			this.ship.setBounty(0, "friendly fire");
		};
	};
};

this.shipDied = function(whom, why)
{
	if(this.ship.hasRole("escape-capsule"))
	{
		return;
	}
	else
	{
		// neutral inits first
		var podType = "escape-capsule";
		var criminalCrew = 0;
		var debrisCount = 0;
		var cargoType = "";
		var cargoPod = "cargopod";
		var cargoLoad = this.ship.cargoSpaceUsed;
		var cargoCount = 0;
				
		if(this.ship.bounty > 7 || this.$SIRF_shipType == "SIRF_gecko_dragon_pirate")
			criminalCrew = 1;
		
		switch(this.$SIRF_shipType) 
		{
			case "SIRF_gecko_dragon":
			
				if(criminalCrew == 1)
					podType = "SIRF_escape_capsule_pirate";	
				else
				{
					podType = "SIRF_escape_capsule";
				};

				debrisCount = 1;	
				break;

			case "SIRF_gecko_dragon_ssg":
			case "SIRF_gecko_dragon_ssg_team_01":
			case "SIRF_gecko_dragon_ssg_team_02":
			
				if(criminalCrew == 1)
					podType = "SIRF_escape_capsule_ssg_pirate";	
				else
				{
					podType = "SIRF_escape_capsule_ssg";
				};

				debrisCount = 1;	
				break;

			case "SIRF_gecko_dragon_pirate":
				
				podType = "SIRF_escape_capsule_pirate";
				debrisCount = 1;
				break;
			
			case "SIRF_shuttle_system":
			case "SIRF_shuttle_system_team_01":
				
				if(criminalCrew == 1)
					podType = "SIRF_escape_capsule_SIRF_pirate";	
				else
				{
					podType = "SIRF_escape_capsule_SIRF";
				};
				
				debrisCount = this.$getRndInteger(1, 2);	
				break;

			case "SIRF_shuttle_system_neutral":
			case "SIRF_shuttle_system_neutral_team_01":
						
				if(criminalCrew == 1)
					podType = "SIRF_escape_capsule_pirate";	
				else
				{
					podType = "SIRF_escape_capsule_neutral";
				};	
				
				debrisCount = this.$getRndInteger(1, 2);	
				break;

			case "SIRF_worm_prospector":
			case "SIRF_worm_prospector_miner":
				
				if(criminalCrew == 1)
					podType = "SIRF_escape_suit_SIRF_pirate";	
				else
				{
					podType = "SIRF_escape_suit_SIRF";
				};
				
				debrisCount = 1;

				// need to check here so that possible findings before come first
				if(cargoLoad == 0)
				{
					if(this.$SIRF_shipType == "SIRF_worm_prospector")
						this.ship.setCargoType("PLENTIFUL_GOODS");
					else
					{
						this.ship.adjustCargo(this.$stationMining(), 2);
						this.ship.adjustCargo(this.$stationMining(), 2);
						this.ship.adjustCargo(this.$stationMining(), 2);
					};		
				};	
				break;
			
			case "SIRF_worm_prospector_neutral":

				if(criminalCrew == 1)
					podType = "SIRF_escape_suit_pirate";	
				else
				{
					podType = "SIRF_escape_suit_neutral";
				};
				
				debrisCount = 1;
			
				if(cargoLoad == 0)
				{
					if(this.ship.primaryRole == "miner")
					{
						this.ship.adjustCargo(this.$stationMining(), 3);
						this.ship.adjustCargo(this.$stationMining(), 3);
					}
					else
					{
						this.ship.setCargoType("PLENTIFUL_GOODS");
					};	
				};
				break;

			// a big explosion with a lot of action, plenty alloys from the core-game so just other debris added
			case "SIRFyard":
			case "SIRF_shipyard_01":
			case "SIRF_shipyard_02":
			case "SIRF_shipyard_03":

				if(cargoLoad == 0)
				{
					this.ship.adjustCargo(this.$stationCargo(2), 3);
					this.ship.adjustCargo(this.$stationCargo(2), 5);
					this.ship.adjustCargo(this.$stationCargo(1), 3);
					this.ship.adjustCargo(this.$stationCargo(1), 5);
					this.ship.adjustCargo(this.$stationMining(), 3);
					this.ship.adjustCargo(this.$stationMining(), 3);
				};	

				system.addShips("SIRF_shuttle_system", this.$getRndInteger(5, 10), this.ship.position);
				system.addShips("SIRF_worm_prospector_lifeboat", this.$getRndInteger(5, 10), this.ship.position);
				system.addShips("SIRF_escape_pod_SIRF", this.$getRndInteger(10, 15), this.ship.position);

				for(var i = this.ship.cargoList.length - 1 ; i >= 0 ; --i)
				{
					cargoType = this.ship.cargoList[i].commodity;
					cargoPod = ("MRP01_container_" + cargoType);
					cargoCount = this.ship.cargoList[i].quantity;
								
					system.addShips(cargoPod, cargoCount, this.ship.position);
				};
				system.addShips("MRP01_container_cash", this.$getRndInteger(2, 6), this.ship.position);
				system.addShips("MRP01_container_prisoners", this.$getRndInteger(2, 4), this.ship.position);

				system.addShips("MRP01_effects_explosive_shrapnel", this.$getRndInteger(20, 40), this.ship.position);	
				system.addShips("gold", this.$getRndInteger(8, 15), this.ship.position);
				system.addShips("platinum", this.$getRndInteger(8, 15), this.ship.position);
				system.addShips("radioactives", this.$getRndInteger(8, 15), this.ship.position);
				debrisCount = (this.ship.fuel.toFixed(0)) * 2;	
				system.addShips("MRP01_effects_burningFuel", debrisCount, this.ship.position);
				return;
			
			default: 
				break;
		};	
		
		// emergency crafts
		system.addShips(podType, debrisCount, this.ship.position);

		// cargopods
		if(cargoLoad > 0)
		{
			for(var i = this.ship.cargoList.length - 1 ; i >= 0 ; --i)
			{
				cargoType = this.ship.cargoList[i].commodity;
				cargoPod = ("MRP01_container_" + cargoType);
				cargoCount = this.ship.cargoList[i].quantity;
							
				system.addShips(cargoPod, cargoCount, this.ship.position);
			};
		};
			
		debrisCount = this.$getRndInteger(3, 6);
		// explosive shrapnels
		system.addShips("MRP01_effects_explosive_shrapnel", debrisCount, this.ship.position);
		// various depris
		system.addShips("MRP01_ship_debris", debrisCount, this.ship.position);
		// burning fuel
		debrisCount = (this.ship.fuel.toFixed(0));	
		system.addShips("MRP01_effects_burningFuel", debrisCount, this.ship.position);
	};
};

this.$stationCargo = function(flip)
{
	// SIRF main imports (market script)
	this.$SIRF_station_cargo_in_Array = ["food", "radioactives", "slaves", "furs"];
	var $SIRF_station_cargo_in = 
	$SIRF_station_cargo_in_Array[Math.floor(Math.random() * $SIRF_station_cargo_in_Array.length)];
	
	// SIRF main exports (market script)
	this.$SIRF_station_cargo_out_Array = ["computers", "machinery", "alloys", "firearms"];
	var $SIRF_station_cargo_out = 
	$SIRF_station_cargo_out_Array[Math.floor(Math.random() * $SIRF_station_cargo_out_Array.length)];

	if(flip == 1)
		$SIRF_station_cargo = $SIRF_station_cargo_in;
	else
	{
		$SIRF_station_cargo = $SIRF_station_cargo_out;	
	};
	
	return ($SIRF_station_cargo);
};

this.$stationMining = function()
{
	this.$SIRF_station_miner_Array = ["alloys", "minerals", "gold", "platinum", "gem_stones"];
	var $SIRF_station_miner = 
	$SIRF_station_miner_Array[Math.floor(Math.random() * $SIRF_station_miner_Array.length)];
		
	return ($SIRF_station_miner);
};

this.$getRndInteger = function(min, max)
{
	return Math.floor(Math.random() * (max - min + 1) ) + min;
};

