this.name			= "SIRF_station_selection_conditions";
this.author			= "Montana05";
this.description	= "Conditions for SIRF tech levels and price factors";
this.version		= "2.60";
this.copyright		= "2021 Montana05";
this.licence   		= "CC BY-NC-SA 4.0";
"use strict";

this.allowSpawnShip = function(shipKey) 
{
	var systemTech = system.techLevel;
	var systemEco = system.economy;
	var systemGov = system.government;
	
	if(system.isInterstellarSpace || system.sun.isGoingNova || system.sun.hasGoneNova || 
		systemGov < 3 || systemTech < 7 || systemTech > 13)
	{
		return false;
	}
		
	switch(shipKey) 
	{
		case "SIRF_shipyard_01":	
			
			if(systemTech == 7 || systemTech == 8)
			{
				log(this.name, "SIRF added to the system, tech level = 9, price factor = 1.10");
				return true;
			}
			break;
			
		case "SIRF_shipyard_02":	
			
			if(systemTech == 9 || systemTech == 10)
			{
				log(this.name, "SIRF added to the system, tech level = 11, price factor = 1.15");
				return true;
			}
			break;
			
		case "SIRF_shipyard_03":	
			
			if(systemTech == 11 || (systemTech == 12 && systemEco != 0))
			{
				log(this.name, "SIRF added to the system, tech level = 13, price factor = 1.20");
				return true;
			}
			break;
			
		case "SIRFyard":	
			
			if((systemTech == 12 && systemEco == 0) || systemTech == 13)
			{
				log(this.name, "SIRF added to the system, tech level = 15, price factor = 1.25");
				return true;
			}
			break;
			
		default:
			break;		
	};
	return false;	
};
	


